<?

/*   search.php3 v.3.0.2 for UdmSearch 3.0.0
 *   (C) 1999,2000 by Sergey Kartashoff aka gluke,
 *                    UdmSearch Developers Team
 *   features: mysql , oracle and postgresql support.
 *             mysql  works only in single-dict table mode
 *             oracle and postgresql works both multi- and single-dict table mode 
 */

require('db_func.inc');

$template_file='udm/search.htm.pgsql.multi';

$DEBUG=0;
$MAX_NP=1000;
$MAX_PS=100;

$dict_table = array ('dict2', 'dict2', 'dict2', 'dict3',
                     'dict4', 'dict5', 'dict6', 'dict7',
                     'dict8', 'dict9', 'dict10','dict11',
                     'dict12','dict16','dict16','dict16',
                     'dict16','dict32');

$self=$PHP_SELF;

$tag=$t;
$tagstr=($tag=="")?"":"AND url.tag=$tag";
$uestr=($ue=="")?"":" AND url.url NOT LIKE '%$ue%' ";

if ($ps=="") $ps=20;
if($np=="") $np=0;

if (($MAX_NP > 0) && ($np>$MAX_NP)) $np=$MAX_NP;
if (($MAX_PS > 0) && ($ps>$MAX_PS)) $ps=$MAX_PS;

$templates=array();

/* Variables used in templates 

$from1;	 $f - num of first doc on page
$to;	 $l - num of last doc on page
$found;  $t - total docs found

$query;  $Q - query
$error;	 $E - error
$wordsinfo;  $W - words info

$nav;	 $V - naVigator
$nav_left;  $NL
$nav_bar;   $NB
$nav_right; $NR
$nav_href;  $NH
$nav_num;   $NP

$self;   $A - form Action
                +
$ue;		 $UE - Document URL
$url;		 $DU - Document URL
$title;		 $DT - Document Title
$rating;	 $DR - Document Rating
$contype;	 $DC - Document Content-type
$lastmod;	 $DM - Document last Modified
$docsize;	 $DS - Document Size
$ndoc;		 $DN - Document No
$desc;		 $DD - Document Description
$keyw;		 $DK - Document Keywords
$text;		 $DX - Document teXt
*/


// -----------------------------------------------
// read_template()
// -----------------------------------------------
function read_template(){
    global $Randoms;
    global $template_file;
    global $templates;
    global $ps, $ul, $ue;

    $names=array('top', 'bottom', 'restop', 'resbot', 'navigator',
		 'res', 'notfound', 'error', 'variables', 'clone',
		 'navleft', 'navbar1', 'navbar0', 'navright');

    $where='';
    
    if (!($fp=fopen($template_file, 'r'))){
	echo "Can't open template file $template_file";
	exit;
    } do {
	$str=fgets($fp, 1024);

        if (preg_match('/value="(.+)"[\s\t]+selected="\$ps"/i',$str,$param)) {
           if (($param[1]) == $ps) {
              $str=preg_replace('/selected="\$ps"/i',"selected",$str);
           } else {
              $str=preg_replace('/selected="\$ps"/i',"",$str);
           }
        } 

        if (preg_match('/value="(.*)"[\s\t]+selected="\$ul"/i',$str,$param)) {
           if (($param[1]) == $ul) {
              $str=preg_replace('/selected="\$ul"/i',"selected",$str);
           } else {
              $str=preg_replace('/selected="\$ul"/i',"",$str);
           }
        } 

	if (substr($str, 0, 4) == "<!--") {
		reset($names);
		while ($name=current($names)){
		    if (strstr($str, "<!--$name")){
			$where=$name;
			$templates["$where"]='';
			break;
		    } elseif (strstr($str, "/$name-->")) {
			$where='';
			break;
		    }
		    next($names);
		}
	}

	if ($where=='variables') {
	    if (ereg("^#",$str)) continue;

	    if (preg_match("/^(.+)[\s\t]+(.+)/",$str,$param)) {
	            $var=$param[1];
		    $value=$param[2];
		    $var=strtolower($var);
		    $var=trim($var);

		    if($var[0]=='r') {
			$rand=0+substr($var,1);
			$frand=rand();
			$frand=$frand/getrandmax()*$value;
			$Randoms[$rand]=floor($frand);
				
		    } else $GLOBALS["$var"]="$value";
	    }
	}
	else
	if ($where!=''){
	    $templates["$where"]=$templates["$where"]."\n".$str;
	}
	
    } while (!feof($fp));

    print $templates["variables"];

    fclose($fp);
}

// -----------------------------------------------
// print_template($t,$echo=1)
// -----------------------------------------------
function print_template($t,$echo=1){
    global $templates;
    global $from, $to, $found, $query, $error, $self;
    global $nav, $wordsinfo;
    global $url, $ue;
    global $title, $rating, $desc, $contype, $lastmod, $docsize, $ndoc;
    global $keyw, $text;
    global $crc, $Randoms, $rec_id, $DEBUG;
    global $serv_table, $clock_template, $timeout_template;
    global $max_url_width;

    $from1=$from+1;

    $urlt=$url;

    if (($max_url_width>0)and
        (strlen($urlt)>$max_url_width)) {
        $urlt=substr($urlt,0,$max_url_width);
        $urlt .= "...";
    }
    
    $str=$templates["$t"];

    $str=ereg_replace('\$SERV_TABLE', "$serv_table", $str);
    $str=ereg_replace('\$CLOCK', "$clock_template", $str);
    $str=ereg_replace('\$TIMEOUT', "$timeout_template", $str);

    $str=ereg_replace('\$f', "$from1", $str);
    $str=ereg_replace('\$l', "$to", $str);
    $str=ereg_replace('\$t', "$found", $str);
    $str=ereg_replace('\$A', $self, $str);

    $str=ereg_replace('\$Q', $query, $str);
    $str=eregi_replace('\$UE', $ue, $str);

    $str=ereg_replace('\$E', $error, $str);
    $str=ereg_replace('\$W', $wordsinfo, $str);

    $str=ereg_replace('\$V', $nav, $str);

    $str=ereg_replace('\$DUT', $urlt, $str);
    $str=ereg_replace('\$DU', $url, $str);
    $str=ereg_replace('\$DT', $title, $str);
    $str=ereg_replace('\$DR', "$rating", $str);
    $str=ereg_replace('\$DX', $text, $str);
    $str=ereg_replace('\$DC', $contype, $str);
    $str=ereg_replace('\$DM', $lastmod, $str);
    $str=ereg_replace('\$DS', "$docsize", $str);
    $str=ereg_replace('\$DN', "$ndoc", $str);
    $str=ereg_replace('\$DD', $desc, $str);
    $str=ereg_replace('\$DK', $keyw, $str);
    
    $sub=$str;
    while($sub=strstr($sub,'$r')){
	$sub=substr($sub,2);
	$pos=0;
	$num='';
	
	while(($sub[$pos]>='0')&&($sub[$pos]<='9')){
		$num.=$sub[$pos++];
	}
	
	$str=ereg_replace('\$r'.$num, ''.$Randoms[$num], $str);
    }
    
    if (strstr($str,'$CL')&&($t=='res')) {
	if($crc<>''){
		$myurl=$url;
		$myct=$contype;
		$mylm=$lastmod;
		
		$query="SELECT url,
		               content_type,
			       last_modified 
			  FROM url 
			 WHERE crc='$crc' 
			   AND rec_id<>'$rec_id'";
		
		if($DEBUG) echo $query,"<BR><HR>";
		
		if(!($res=query($query))) print_error_local('Query error:'.$query."\n<BR>".db_error());
		
		while($row=fetch_row($res)){
		    $url=$row[0];
		    $contype=$row[1];
		    $lastmod=$row[2];
		    $clon.=print_template('clone',0);
		}
		
		free_result($res);
		$url=$myurl;$contype=$myct;$lastmod=$mylm;
	}
	$str=ereg_replace('\$CL', $clon, $str);
    }
    
    if($echo) echo $str; else return $str;
}

// -----------------------------------------------
// print_error_local($str)
// -----------------------------------------------
function print_error_local($str){
    global $error;
    
    $error=$str;
    print_template('error');
    print_template('bottom');
    exit;
}

// -----------------------------------------------
// ParseStr($qwe)
// -----------------------------------------------
function ParseStr($qwe){

  $qwe=ereg_replace("[^ &|~()ţ0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ]{1,}","&",$qwe);
  $qwe=ereg_replace("^ {0,}","",$qwe);
  $qwe=ereg_replace(" {0,}\| {0,}","|",$qwe);
  $qwe=ereg_replace(" {0,}\& {0,}","&",$qwe);
  $qwe=ereg_replace(" {0,}\( {0,}","(",$qwe);
  $qwe=ereg_replace(" {0,}\) {0,}",")",$qwe);
  $qwe=ereg_replace(" {0,}\~ {0,}","~",$qwe);
  $qwe=ereg_replace(" {1,}","|",$qwe);
  $qwe=ereg_replace("\|{1,}","|",$qwe);
  $qwe=ereg_replace("&{1,}","&",$qwe);  
  $qwe=ereg_replace("\|\&\|","&",$qwe);
  $qwe=ereg_replace("[\|\&]{1,}$","",$qwe);
  $qwe=ereg_replace("^[\|\&]{1,}","",$qwe);

  return($qwe);
}

// -----------------------------------------------
// ParseQ($q)
// -----------------------------------------------
function ParseQ($q){
   if (ereg_replace(" ","",$q)==''){
       print_template('bottom');
       exit;
   }               
   
   $q=ParseStr($q);
   
   $q=ereg_replace("\&"," && ",$q);
   $q=ereg_replace("\|"," || ",$q);
   $q=ereg_replace("\~"," ! ",$q);
   $q=ereg_replace("\("," ( ",$q);
   $q=ereg_replace("\)"," ) ",$q);
   $q="( $q )"; 
   $q=ereg_replace(" {1,}"," ",$q);

   return $q;
}

// -----------------------------------------------
// init()
// -----------------------------------------------
function init(){
   global $q, $query, $query_orig;

   srand((double)microtime()*1000000);

   if (isset($q)) {
       $query=htmlspecialchars($q);
   } else {
       $query='';
   }
   
   $query_orig=$q;
   
   read_template();
   print_template('top');
   flush();
   
   $q=ParseQ($q);
}

// -----------------------------------------------
// init_stop_words()
// -----------------------------------------------
function init_stop_words(){
   global $stopwords;
   global $DEBUG;

   $stopwords=array();
   
   $query="SELECT word FROM stopword";
   	  
   if ($DEBUG) echo $query,"<BR><HR>";
   
   if (!($res=query($query))) print_error_local('Query error: '.$query."\n<BR>".db_error());
   
   while($row=fetch_row($res)){
       $stopwords[$row[0]]=1;
   }

   free_result($res);
}

// -----------------------------------------------
// get_dict_tab(word)
// -----------------------------------------------
function get_dict_tab($word) {
   global $dict_table;

   if (strlen($word)>16) return $dict_table[16];
   return $dict_table[strlen($word)];
}

// -----------------------------------------------
// last_parse($q)
// -----------------------------------------------
function last_parse($q){
   global $stopwords;
   global $dbtype;
   global $dbmode;
   global $ul, $ue, $uestr;
   global $tagstr;
   global $DEBUG;
   global $temp_table;

   $state=0;
   $qu="";
   $w=""; 
   $n=0;
   $t=strtok($q," ");
   $words=array();
   
   while(($t!="")&&($error=="")){
     if(isset($stopwords[$t])) {
       $t='';
     }
   
     switch($state){
       case 0;  
       if(($t=="||")||($t=="&&")||($t==")")) $error="at '$t'";
       else if($t=="!") { 
         $state=0;
         $qu="$qu NOT "; break;
       }
       else if($t=="("){
         $n++;
         $state=0;
         $qu="$qu(";
       }
       else {
         $words[] = $t;

         switch ($dbtype) {
            case 'mysql' : $qu="$qu sum(word='$t')>0"; break;
            case 'oracle': $qu="$qu sum(decode(word,'$t',1,0))>0 "; break;
            case 'pgsql' : $qu="$qu sum(case word when '$t' then 1 else 0 end)>0 "; break;
            default      : $qu="$qu sum(word='$t')>0"; break;
         } 

         if($w=="") $w="'$t'";
         else $w="$w,'$t'";
         $state=1;
       }
       break;
       
       case 1;  
       if(($t=="||")||($t=="&&")){
         $state=0;
         if ($t=='||') $qu="$qu OR ";
         else $qu="$qu AND ";
       }
       else if($t==")") {
         $n--;
         $state=1;
         $qu="$qu)";
       }
       else
         $error=" at '$t'";
       break;
     }
     $t=strtok(" ");
   }
   
   if($error=="" && $n != 0) $error='Unmatched brackets';
   if($error!="") print_error_local($error);

   if (($dbtype == 'mysql') || ($dbtype == '')) $sql_small = 'SQL_SMALL_RESULT';

   if ($dbmode == 'multi') {
// ------------------
// DBMode = multi
      $query="";

      if ($dbtype == 'pgsql') {
      	 $make_temp_table=1;
      	 $temp_table = 't'.time().rand(1000000,9999999);
      } else {
         $make_temp_table=0;
         $temp_table="";
      }

      for ($i=0; $i<count($words); $i++) {
         $dict=get_dict_tab($words[$i]);

         if ($query=="") {
            if ($make_temp_table == 0) {
               $query="SELECT url_id,word,intag
                         FROM $dict
                        WHERE word in ('$words[$i]')";
            } else {
               $query="SELECT url_id,word,intag
                         INTO TEMP $temp_table
                         FROM $dict
                        WHERE word in ('$words[$i]')";
            }
         } else {
            $query.=" UNION ALL
                     SELECT url_id,word,intag
                       FROM $dict
                      WHERE word in ('$words[$i]')";
         }
      }

      if ($make_temp_table == 1) {
         if($DEBUG) echo $query,"<BR><HR>";
         if (!($temp_table_res=query($query))) print_error_local('Query error: '.$query."\n<BR>".db_error());;
         free_result($temp_table_res);
      }

      if($ul||$uestr||$tagstr) {
         if ($dbtype == 'oracle') {
                 $query_url_id="SELECT url_id,
                                       sum(intag) as r 
                                  FROM url, ($query) 
             	                 WHERE url.rec_id=url_id 
             	                   AND url.url LIKE '%$ul%'
                                   $uestr
             	                   $tagstr 
             	                 GROUP BY url_id 
             	             HAVING ($qu)
             	              ORDER BY r DESC";
           
                 $query_count_url_id="SELECT count(*)
                                        FROM (
                                           SELECT url_id
                                             FROM url, ($query) 
                      	                    WHERE url.rec_id=url_id 
                      	                      AND url.url LIKE '%$ul%'
                                              $uestr
                      	                      $tagstr 
                      	                    GROUP BY url_id
                      	                   HAVING ($qu)
                                        )";

         } elseif ($dbtype == 'pgsql') {
                 $query_url_id="SELECT url_id,
                                       sum(intag) as r 
                                  FROM url, $temp_table 
             	                 WHERE url.rec_id=url_id 
             	                   AND url.url LIKE '%$ul%'
                                   $uestr
             	                   $tagstr 
             	                 GROUP BY url_id 
             	             HAVING ($qu)
             	              ORDER BY r DESC";
           
                 $query_count_url_id="";
         }
      } else {
         // not ul,ue nor tagstr
         if ($dbtype == 'oracle') {
                 $query_url_id="SELECT url_id,
                                       sum(intag) as r 
             	                  FROM ($query) 
             	                 GROUP BY url_id 
             	                HAVING ($qu)
             	                 ORDER BY r DESC";
           
                 $query_count_url_id="SELECT count(*)
                                        FROM (
             	                           SELECT url_id
             	                             FROM ($query) 
             	                            WHERE word in ($w)
             	                            GROUP BY url_id 
             	                           HAVING ($qu)
             	                        )";
         } elseif ($dbtype == 'pgsql') {
                 $query_url_id="SELECT url_id,
                                       sum(intag) as r 
             	                  FROM $temp_table 
             	                 GROUP BY url_id 
             	                HAVING ($qu)
             	                 ORDER BY r DESC";
           
                 $query_count_url_id="";
         }
      }

   } else {
// ------------------
// DBMode = single 

      if($ul||$uestr||$tagstr) {
         $query_url_id="SELECT $sql_small
                               dict.url_id,
                               sum(dict.intag) as r 
                          FROM url,dict 
     	                 WHERE url.rec_id=dict.url_id 
     	                   AND url.url LIKE '%$ul%'
                           $uestr
     	                   $tagstr 
     	                   AND dict.word in ($w) 
     	                 GROUP BY url_id 
     	             HAVING ($qu)
     	              ORDER BY r DESC";
   
         $query_count_url_id="SELECT count(*)
                                FROM (
                                   SELECT dict.url_id
                                     FROM url,dict 
              	                    WHERE url.rec_id=dict.url_id 
              	                      AND url.url LIKE '%$ul%'
                                      $uestr
              	                      $tagstr 
              	                      AND dict.word in ($w) 
              	                    GROUP BY dict.url_id
              	                   HAVING ($qu)
                                )";
      } else {
         $query_url_id="SELECT $sql_small
                               dict.url_id,
                               sum(dict.intag) as r 
     	                  FROM dict 
     	                 WHERE dict.word in ($w) 
     	                 GROUP BY url_id 
     	                HAVING ($qu)
     	                 ORDER BY r DESC";
   
         $query_count_url_id="SELECT count(*)
                                FROM (
     	                           SELECT dict.url_id
     	                             FROM dict 
     	                            WHERE dict.word in ($w)
     	                            GROUP BY dict.url_id 
     	                           HAVING ($qu)
     	                        )";
      }
   }

   $query_url="SELECT $sql_small
                      url.url,
                      url.title,
      	              url.txt,
      	              url.content_type,
      	              url.docsize,
      	              url.last_modified,
      	              url.keywords,
      	              url.description,
      	              url.crc,
      	              url.rec_id
                 FROM url
                WHERE url.rec_id = %URL_IN%";

   return array($query_url_id,$query_url,$query_count_url_id);
}

// -----------------------------------------------
// make_nav($query_orig)
// -----------------------------------------------
function make_nav($query_orig){
   global $found,$np,$isnext,$ps,$tag,$ul,$ue,$self;

   $q=ereg_replace(" ","+",$query_orig);
   $q=ereg_replace("&","%26",$q);
   
   if($np>0){
     $prevp=$np-1;
     $prev_href="$self?q=$q&np=$prevp&ps=$ps&t=$tag&ul=$ul&ue=$ue";

     $nav_left=print_template('navleft',0);
     $nav_left=ereg_replace('\$NH',"$prev_href",$nav_left);
   }
   if($isnext==1) {
     $nextp=$np+1;
     $next_href="$self?q=$q&np=$nextp&ps=$ps&t=$tag&ul=$ul&ue=$ue";

     $nav_right=print_template('navright',0);
     $nav_right=ereg_replace('\$NH',"$next_href",$nav_right);
   }

   $nav_bar0=print_template('navbar0',0);
   $nav_bar1=print_template('navbar1',0);

   $tp=ceil($found/$ps);

   $cp=$np+1;

   if ($cp>5) {
      $lp=$cp-5;
   } else {
      $lp=1;
   }

   $rp=$lp+10-1;
   if ($rp>$tp) {
      $rp=$tp;
      $lp=$rp-10+1;
      if ($lp<1) $lp=1;
   }

   if ($lp!=$rp) {
      for ($i=$lp; $i<=$rp;$i++) {
         $realp=$i-1;
   
         if ($i==$cp) {
            $nav_bar=$nav_bar.$nav_bar0;
         } else {
            $nav_bar=$nav_bar.$nav_bar1;
         }
         
         $href="$self?q=$q&np=$realp&ps=$ps&t=$tag&ul=$ul&ue=$ue";
   
         $nav_bar=ereg_replace('\$NP',"$i",$nav_bar);
         $nav_bar=ereg_replace('\$NH',"$href",$nav_bar);
      }
   
      $nav=print_template('navigator',0);
      $nav=ereg_replace('\$NL',"$nav_left",$nav);
      $nav=ereg_replace('\$NR',"$nav_right",$nav);
      $nav=ereg_replace('\$NB',"$nav_bar",$nav);
   }

   return $nav;
}

// -----------------------------------------------
//  M A I N 
// -----------------------------------------------

init();
initdb();
init_stop_words();

list($query_url_id,$query_url,$query_count_url_id)=last_parse($q);
	     
if($DEBUG) echo $query_url_id,"<BR><HR>";

if (!($res=query($query_url_id))) print_error_local('Query error: '.$query_url_id."\n<BR>".db_error());

$from=IntVal($np)*IntVal($ps); 
$to=IntVal($np+1)*IntVal($ps); 

if (($dbtype == 'mysql') ||
    ($dbtype == 'pgsql') ||
    ($dbtype == '')) {
   $found=db_numrows($res);
} else {
   if($DEBUG) echo $query_count_url_id,"<BR><HR>";

   if (!($res2=query($query_count_url_id)))  print_error_local('Query error: '.$query_count_url_id."\n<BR>".db_error());

   $row=fetch_row($res2);
   $found=$row[0];

   free_result($res2);
}

if($to>$found) $to=$found;
if (($from+$ps)<$found) $isnext=1;
$nav=make_nav($query_orig);

if ($found>0) {
    print_template('restop');
} else {
    print_template('notfound');
    print_template('bottom');
    exit;
}

$data_seek=db_data_seek($res,$from);
if (! $data_seek) {
    print_template('notfound');
    print_template('bottom');
    exit;
}

$url_id_array=array();
$rating_array=array();

for ($i=0; $i<$ps; $i++) {
  $row=fetch_row($res);

  if (!$row) break;

  $url_id_array[] = $row[0];
  $rating_array[] = $row[1];
}

free_result($res);

if ($temp_table != "") {
   $drop_temp_query="DROP TABLE $temp_table";
   if($DEBUG) echo $drop_temp_query,"<BR><HR>";

   if (!($drop_res=query($drop_temp_query))) print_error_local('Query error: '.$drop_temp_query."\n<BR>".db_error());
   free_result($drop_res);
}

$ndoc=$from+1;
for ($i=0; $i<count($url_id_array); $i++) {

  $query=ereg_replace("%URL_IN%",$url_id_array[$i],$query_url);
  $rating=$rating_array[$i];

  if($DEBUG) echo $query,"<BR><HR>";
  if (!($res=query($query))) print_error_local('Query error: '.$query."\n<BR>".db_error());
  
  $data=fetch_row($res);
  free_result($res);

  $url=$data[0];
  $title=$data[1];
  $title=($title) ? htmlspecialChars($title):'No title';
  $text=htmlspecialChars($data[2]);
  $contype=$data[3];
  $docsize=$data[4];
  $lastmod=$data[5];
  $keyw=htmlspecialChars($data[6]);
  $desc=htmlspecialChars($data[7]);
  $crc=$data[8];
  $rec_id=0+$data[9];
  
  print_template('res');
  
  $ndoc++;
}

print_template('resbot');    
print_template('bottom');

?>
